VERSION 5.00
Begin VB.Form frmDrawText 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "DrawText Demo"
   ClientHeight    =   5115
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4665
   Icon            =   "frmDrawText.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5115
   ScaleWidth      =   4665
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdDraw 
      Caption         =   "Draw Text"
      Height          =   315
      Left            =   3375
      TabIndex        =   3
      Top             =   4725
      Width           =   1215
   End
   Begin VB.Frame fraFlags 
      Caption         =   "DrawText flags"
      Height          =   1890
      Left            =   75
      TabIndex        =   2
      Top             =   2775
      Width           =   4515
      Begin VB.CheckBox wordbreak 
         Caption         =   "DT_WORDBREAK"
         Height          =   195
         Left            =   2325
         TabIndex        =   17
         Top             =   1125
         Value           =   1  'Checked
         Width           =   2000
      End
      Begin VB.CheckBox wordellipsis 
         Caption         =   "DT_WORD_ELLIPSIS"
         Height          =   195
         Left            =   75
         TabIndex        =   16
         Top             =   1575
         Width           =   2000
      End
      Begin VB.CheckBox vcenter 
         Caption         =   "DT_VCENTER"
         Height          =   195
         Left            =   2325
         TabIndex        =   15
         Top             =   900
         Width           =   2000
      End
      Begin VB.CheckBox dttop 
         Caption         =   "DT_TOP"
         Height          =   195
         Left            =   2325
         TabIndex        =   14
         Top             =   675
         Width           =   2000
      End
      Begin VB.CheckBox dtright 
         Caption         =   "DT_RIGHT"
         Height          =   195
         Left            =   75
         TabIndex        =   13
         Top             =   675
         Width           =   2000
      End
      Begin VB.CheckBox noprefix 
         Caption         =   "DT_NOPREFIX"
         Height          =   195
         Left            =   2325
         TabIndex        =   12
         Top             =   1350
         Width           =   2000
      End
      Begin VB.CheckBox noclip 
         Caption         =   "DT_NOCLIP"
         Height          =   195
         Left            =   2325
         TabIndex        =   11
         Top             =   1575
         Width           =   2000
      End
      Begin VB.CheckBox dtleft 
         Caption         =   "DT_LEFT"
         Height          =   195
         Left            =   75
         TabIndex        =   10
         Top             =   225
         Value           =   1  'Checked
         Width           =   2000
      End
      Begin VB.CheckBox pathellipsis 
         Caption         =   "DT_PATH_ELLIPSIS"
         Height          =   195
         Left            =   75
         TabIndex        =   9
         Top             =   1125
         Width           =   2000
      End
      Begin VB.CheckBox endellipsis 
         Caption         =   "DT_END_ELLIPSIS "
         Height          =   195
         Left            =   75
         TabIndex        =   8
         Top             =   1350
         Width           =   2000
      End
      Begin VB.CheckBox editcontrol 
         Caption         =   "DT_EDITCONTROL"
         Height          =   195
         Left            =   75
         TabIndex        =   7
         Top             =   900
         Width           =   2000
      End
      Begin VB.CheckBox center 
         Caption         =   "DT_CENTER"
         Height          =   195
         Left            =   75
         TabIndex        =   6
         Top             =   450
         Width           =   2000
      End
      Begin VB.CheckBox singleline 
         Caption         =   "DT_SINGLELINE"
         Height          =   195
         Left            =   2325
         TabIndex        =   5
         Top             =   225
         Width           =   2000
      End
      Begin VB.CheckBox dtbottom 
         Caption         =   "DT_BOTTOM"
         Height          =   195
         Left            =   2325
         TabIndex        =   4
         Top             =   450
         Width           =   2000
      End
   End
   Begin VB.TextBox txtSource 
      Height          =   915
      Left            =   75
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Text            =   "frmDrawText.frx":000C
      Top             =   1800
      Width           =   4515
   End
   Begin VB.PictureBox picTarget 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   1665
      Left            =   75
      ScaleHeight     =   1665
      ScaleWidth      =   4515
      TabIndex        =   0
      Top             =   75
      Width           =   4515
   End
End
Attribute VB_Name = "frmDrawText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This code is by Alex Vallat.  See www.comports.com/AlexV for more programs and sample
'code by the same author.  This code is freely distributable PROVIDED THIS MESSAGE IS
'LEFT INTACT.  (c)Alex Vallat 2000.
'=====================================================================================

Option Explicit
'API Declares:
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Type RECT
        dtleft As Long
        dttop As Long
        dtright As Long
        dtbottom As Long
End Type

Private Const DT_dtbottom = &H8
Private Const DT_CENTER = &H1
Private Const DT_dtleft = &H0
Private Const DT_NOCLIP = &H100
Private Const DT_NOPREFIX = &H800
Private Const DT_dtright = &H2
Private Const DT_SINGLELINE = &H20
Private Const DT_dttop = &H0
Private Const DT_VCENTER = &H4
Private Const DT_WORDBREAK = &H10
Private Const DT_EDITCONTROL = &H2000
Private Const DT_PATH_ELLIPSIS = &H4000
Private Const DT_END_ELLIPSIS = &H8000
Private Const DT_WORD_ELLIPSIS = &H40000
'End API Declares

'These flags require the singleline flag to work:
Private Sub dtbottom_Click()
    If dtbottom.Value = 1 Then singleline.Value = 1
End Sub
Private Sub dttop_Click()
    If dttop.Value = 1 Then singleline.Value = 1
End Sub
Private Sub vcenter_Click()
    If vcenter.Value = 1 Then singleline.Value = 1
End Sub
'End auto singleline flags

Private Sub cmdDraw_Click()
    Dim srcRect As RECT, fmtFlags As Long

'Add up all the checked flags
    fmtFlags = 0
    fmtFlags = fmtFlags Or (dtbottom * DT_dtbottom)
    fmtFlags = fmtFlags Or (center * DT_CENTER)
    fmtFlags = fmtFlags Or (dtleft * DT_dtleft)
    fmtFlags = fmtFlags Or (noclip * DT_NOCLIP)
    fmtFlags = fmtFlags Or (noprefix * DT_NOPREFIX)
    fmtFlags = fmtFlags Or (dtright * DT_dtright)
    fmtFlags = fmtFlags Or (singleline * DT_SINGLELINE)
    fmtFlags = fmtFlags Or (dttop * DT_dttop)
    fmtFlags = fmtFlags Or (vcenter * DT_VCENTER)
    fmtFlags = fmtFlags Or (wordbreak * DT_WORDBREAK)
    fmtFlags = fmtFlags Or (editcontrol * DT_EDITCONTROL)
    fmtFlags = fmtFlags Or (pathellipsis * DT_PATH_ELLIPSIS)
    fmtFlags = fmtFlags Or (endellipsis * DT_END_ELLIPSIS)
    fmtFlags = fmtFlags Or (wordellipsis * DT_WORD_ELLIPSIS)
'End Adding flags

'Calculate text rectangle
    'Get picturebox rect
    GetWindowRect picTarget.hwnd, srcRect
    
    'Transform to picturebox co-ordinates
    srcRect.dtright = srcRect.dtright - srcRect.dtleft
    srcRect.dtbottom = srcRect.dtbottom - srcRect.dttop
    srcRect.dttop = 0
    srcRect.dtleft = 0
'End Calculating rectangle
    
    'Clear previous text
    picTarget.Cls
    
    'Draw new text
    DrawText picTarget.hdc, txtSource.Text, -1, srcRect, fmtFlags
End Sub
